// Generated by gen_catalog.dart.
//
// Copyright 2020 Google LLC.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/// CRC functions from the catalog at
/// https://reveng.sourceforge.io/crc-catalogue/all.htm.

import 'package:crclib/crclib.dart';

class Crc40Gsm extends ParametricCrc {
  Crc40Gsm()
      : super(
          40,
          BigInt.parse('0004820009', radix: 16),
          BigInt.parse('0000000000', radix: 16),
          BigInt.parse('ffffffffff', radix: 16),
          inputReflected: false,
          outputReflected: false);
}

class Crc64Ecma182 extends ParametricCrc {
  Crc64Ecma182()
      : super(
          64,
          BigInt.parse('42f0e1eba9ea3693', radix: 16),
          BigInt.parse('0000000000000000', radix: 16),
          BigInt.parse('0000000000000000', radix: 16),
          inputReflected: false,
          outputReflected: false);
}

/// An alias of `Crc64Ecma182`.
class Crc64 extends Crc64Ecma182 {}
class Crc64GoIso extends ParametricCrc {
  Crc64GoIso()
      : super(
          64,
          BigInt.parse('000000000000001b', radix: 16),
          BigInt.parse('ffffffffffffffff', radix: 16),
          BigInt.parse('ffffffffffffffff', radix: 16),
          inputReflected: true,
          outputReflected: true);
}

class Crc64WE extends ParametricCrc {
  Crc64WE()
      : super(
          64,
          BigInt.parse('42f0e1eba9ea3693', radix: 16),
          BigInt.parse('ffffffffffffffff', radix: 16),
          BigInt.parse('ffffffffffffffff', radix: 16),
          inputReflected: false,
          outputReflected: false);
}

class Crc64Xz extends ParametricCrc {
  Crc64Xz()
      : super(
          64,
          BigInt.parse('42f0e1eba9ea3693', radix: 16),
          BigInt.parse('ffffffffffffffff', radix: 16),
          BigInt.parse('ffffffffffffffff', radix: 16),
          inputReflected: true,
          outputReflected: true);
}

/// An alias of `Crc64Xz`.
class Crc64GoEcma extends Crc64Xz {}
